/* sniff_eib, bernd thallner, bernd@kangaroo.at */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>

int main(void) {
  int i, len, bcu_fd, target_fd;
  fd_set rfds;
  unsigned char buf[255];

  bcu_fd=open("/dev/eib", O_RDWR | O_NONBLOCK);
  if(bcu_fd<0)
    return 1;

  target_fd=open("/dev/eib_sniff", O_RDWR | O_NONBLOCK);
  if(target_fd<0)
    return 1;

  while(1) {

    FD_ZERO(&rfds);
    FD_SET(bcu_fd, &rfds);
    FD_SET(target_fd, &rfds);

    select(target_fd+1, &rfds, NULL, NULL, NULL);
    len=read(bcu_fd, buf, 255);
    if(len>0) {
      write(target_fd, buf, len);
      printf("bcu->target:");
       for(i=0; i<len; i++)
	fprintf(stdout, " %02x", buf[i]);
      printf("\n");
    }
    len=read(target_fd, buf, 255);
    if(len>0) {
      write(bcu_fd, buf, len);
      printf("target->bcu:");
       for(i=0; i<len; i++)
	fprintf(stdout, " %02x", buf[i]);
      printf("\n");
    }
  }

  close(bcu_fd);
  close(target_fd);
  return 0;
}

